--[[
  MTarget - Tank Assignment Functions ($Id: MTarget_TankAssign.lua 89 2012-09-27 06:18:42Z gameldar $)
  Written by gameldar
  http://www.wowace.com/projects/mtarget

  Thanks to:
    Ace3: Great lib framework
  ]]--

function MTarget:TankAssign_OnInitialize()
end
function MTarget:TankAssign_OnEnable()
  MTarget:RegisterEvent("RAID_ROSTER_UPDATE");
end

function MTarget:RAID_ROSTER_UPDATE()
  if (MTarget.db.profile.tankassign) then
  MTarget:Debug("Raid Roster Update!");
    local maintank = nil;
    local mainassist = nil;
    local tanks = {}; 
    local unitNamePrefix;
    if (IsInRaid()) then
      unitNamePrefix = "raid";
    else
      unitNamePrefix = "party";
    end
    MTarget:Debug("prefix: " .. unitNamePrefix);
    local i;
    
    for i = 1, GetNumGroupMembers() do
      local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
      MTarget:Debug(name .. " role is " .. (role or "nil"));
      if (role == "MAINTANK") then
        maintank = name;
      else
        if (role == "MAINASSIST") then
          mainassist = name;
        end
      end
      local uid;
      if (i == 1) then
	uid = "player";
      else
        uid = unitNamePrefix .. (i - 1);
      end
      if (UnitGroupRolesAssigned(uid) == "TANK") then
        table.insert(tanks, name);
      end
    end
    if (MTarget.db.profile.tankroles) then
      if (not maintank) then
        for i = 0, #tanks do
  	  if (not maintank) then
  	    maintank = tanks[i];
  	  else
  	    mainassist = tanks[i];
  	  end
        end
      end
    end

    if (maintank) then
      MTarget:SetVariable("maintank", maintank);
    end
    if (mainassist) then
      MTarget:SetVariable("mainassist", mainassist);
    end
  end
end
